---
title: llarp::apple::RouteManager

---

# llarp::apple::RouteManager





Inherits from [llarp::vpn::IRouteManager](Classes/classllarp_1_1vpn_1_1IRouteManager.md)

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[RouteManager](Classes/classllarp_1_1apple_1_1RouteManager.md#function-routemanager)**(llarp::Context & ctx, llarp_route_callbacks rcs, void * callback_context) |
| void | **[AddRoute](Classes/classllarp_1_1apple_1_1RouteManager.md#function-addroute)**(IPVariant_t ip, IPVariant_t gateway) override<br>These are called for poking route holes, but we don't have to do that at all on macos because the appex isn't subject to its own rules.  |
| void | **[DelRoute](Classes/classllarp_1_1apple_1_1RouteManager.md#function-delroute)**(IPVariant_t ip, IPVariant_t gateway) override |
| void | **[AddDefaultRouteViaInterface](Classes/classllarp_1_1apple_1_1RouteManager.md#function-adddefaultrouteviainterface)**(std::string ifname) override |
| void | **[DelDefaultRouteViaInterface](Classes/classllarp_1_1apple_1_1RouteManager.md#function-deldefaultrouteviainterface)**(std::string ifname) override |
| virtual void | **[AddRouteViaInterface](Classes/classllarp_1_1apple_1_1RouteManager.md#function-addrouteviainterface)**([vpn::NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md) & vpn, [IPRange](Classes/structllarp_1_1IPRange.md) range) override |
| virtual void | **[DelRouteViaInterface](Classes/classllarp_1_1apple_1_1RouteManager.md#function-delrouteviainterface)**([vpn::NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md) & vpn, [IPRange](Classes/structllarp_1_1IPRange.md) range) override |
| virtual std::vector< IPVariant_t > | **[GetGatewaysNotOnInterface](Classes/classllarp_1_1apple_1_1RouteManager.md#function-getgatewaysnotoninterface)**(std::string ifname) override |

## Additional inherited members

**Public Functions inherited from [llarp::vpn::IRouteManager](Classes/classllarp_1_1vpn_1_1IRouteManager.md)**

|                | Name           |
| -------------- | -------------- |
| | **[IRouteManager](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-iroutemanager)**() =default |
| | **[IRouteManager](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-iroutemanager)**(const [IRouteManager](Classes/classllarp_1_1vpn_1_1IRouteManager.md) & ) =delete |
| | **[IRouteManager](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-iroutemanager)**([IRouteManager](Classes/classllarp_1_1vpn_1_1IRouteManager.md) && ) =delete |
| virtual | **[~IRouteManager](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-~iroutemanager)**() =default |
| virtual const [llarp::net::Platform](Classes/classllarp_1_1net_1_1Platform.md) * | **[Net_ptr](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-net-ptr)**() const |
| const [llarp::net::Platform](Classes/classllarp_1_1net_1_1Platform.md) & | **[Net](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-net)**() const |
| virtual void | **[AddBlackhole](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-addblackhole)**() |
| virtual void | **[DelBlackhole](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-delblackhole)**() |


## Public Functions Documentation

### function RouteManager

```cpp
inline RouteManager(
    llarp::Context & ctx,
    llarp_route_callbacks rcs,
    void * callback_context
)
```


### function AddRoute

```cpp
inline void AddRoute(
    IPVariant_t ip,
    IPVariant_t gateway
) override
```

These are called for poking route holes, but we don't have to do that at all on macos because the appex isn't subject to its own rules. 

### function DelRoute

```cpp
inline void DelRoute(
    IPVariant_t ip,
    IPVariant_t gateway
) override
```


### function AddDefaultRouteViaInterface

```cpp
void AddDefaultRouteViaInterface(
    std::string ifname
) override
```


### function DelDefaultRouteViaInterface

```cpp
void DelDefaultRouteViaInterface(
    std::string ifname
) override
```


### function AddRouteViaInterface

```cpp
virtual void AddRouteViaInterface(
    vpn::NetworkInterface & vpn,
    IPRange range
) override
```


**Reimplements**: [llarp::vpn::IRouteManager::AddRouteViaInterface](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-addrouteviainterface)


### function DelRouteViaInterface

```cpp
virtual void DelRouteViaInterface(
    vpn::NetworkInterface & vpn,
    IPRange range
) override
```


**Reimplements**: [llarp::vpn::IRouteManager::DelRouteViaInterface](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-delrouteviainterface)


### function GetGatewaysNotOnInterface

```cpp
inline virtual std::vector< IPVariant_t > GetGatewaysNotOnInterface(
    std::string ifname
) override
```


-------------------------------

Updated on 2022-09-03 at 19:01:05 +0000