---
title: llarp/win32/wintun.hpp

---

# llarp/win32/wintun.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::vpn](Namespaces/namespacellarp_1_1vpn.md)**  |
| **[llarp::win32](Namespaces/namespacellarp_1_1win32.md)**  |




## Source code

```cpp
#pragma once

#include <memory>

#include <windows.h>

namespace llarp
{
  struct AbstractRouter;
}

namespace llarp::vpn
{
  struct InterfaceInfo;
  class NetworkInterface;
}  // namespace llarp::vpn

namespace llarp::win32
{
  class WintunContext;

  std::shared_ptr<WintunContext>
  WintunContext_new();

  std::shared_ptr<vpn::NetworkInterface>
  WintunInterface_new(
      const std::shared_ptr<WintunContext>&,
      const vpn::InterfaceInfo& info,
      AbstractRouter* router);

}  // namespace llarp::win32
```


-------------------------------

Updated on 2022-09-03 at 19:01:07 +0000
